> ## Documentation Index
> Fetch the complete documentation index at: https://docs.methodfi.com/llms.txt
> Use this file to discover all available pages before exploring further.

# List all Events

export const get_pagination_defaults = (resource_name = 'records') => [{
  name: 'from_date',
  type: 'string',
  required: false,
  description: `ISO 8601 formatted date (YYYY-MM-DD) to filter for ${resource_name} created on or after the date provided.`
}, {
  name: 'to_date',
  type: 'string',
  required: false,
  description: `ISO 8601 formatted date (YYYY-MM-DD) to filter for ${resource_name} created on or before the date provided.`
}, {
  name: 'page',
  type: 'string',
  required: false,
  description: `The page number to return.`
}, {
  name: 'page_cursor',
  type: 'string',
  required: false,
  description: <>
        The ID of a resource from which a page should start or end. Mutually exclusive with <code>page</code>.
      </>
}, {
  name: 'page_limit',
  type: 'string',
  required: false,
  description: `The number of ${resource_name} to return per page. Default and maximum is 100.`
}];

export const ParamList = ({items = [], is_child = false}) => {
  return items.map(item => {
    const field_props = {
      id: Math.random().toString(),
      body: item.name,
      name: item.name,
      type: item.type,
      required: item.required
    };
    const enums = item.enums || [];
    const items = item.items || [];
    const has_items = items?.length > 0;
    const has_enums = enums?.length > 0;
    const should_default_open = item.defaultOpen || false;
    const render_child_item = () => {
      const child_props = {
        title: has_enums ? "Possible enum values" : "properties"
      };
      if (should_default_open) child_props.defaultOpen = true;
      const has_inline_enums = has_enums && enums.every(enum_item => typeof enum_item === 'string') && enums.map((enum_item, idx) => {
        const is_last = idx === enums.length - 1;
        const is_2nd_to_last = idx === enums.length - 2;
        return <>
            <code>{enum_item}</code>
            {is_last && ''}
            {is_2nd_to_last && ' or '}
            {!is_last && !is_2nd_to_last && ', '}
          </>;
      });
      const enum_list = has_enums && !has_inline_enums && <Accordion {...child_props}>
          {enums.map((enum_item, index) => <div key={`enum-${index}`}>
              <code>{enum_item.name}</code>
              <br />
              <p>{enum_item.description}</p>
            </div>)}
        </Accordion>;
      const item_list = has_items && <Expandable {...child_props}>
          <ParamList items={items || []} is_child />
        </Expandable>;
      return <>
          <p>
            {item.description}
            {has_inline_enums && [has_inline_enums.length > 1 ? ' One of ' : ' Must be ', ...has_inline_enums]}
          </p>

          {enum_list}
          {item_list}
        </>;
    };
    return is_child ? <ResponseField {...field_props}>{render_child_item()}</ResponseField> : <ParamField {...field_props}>{render_child_item()}</ParamField>;
  });
};

Returns a list of Events that satisfy the provided filters.

## Query Parameters

<ParamList
  items={[
{
name: 'resource_id',
type: 'string',
required: false,
description: 'Filter events by the associated resource ID.',
},
{
name: 'resource_type',
type: 'enum',
required: false,
description: 'Filter events by the type of resource.',
enums: ['payment', 'entity', 'account', 'credit_score'],
},
{
name: 'type',
type: 'string',
required: false,
description: 'Filter events by the event type (e.g., payment.update, credit_score.increased).',
},
...get_pagination_defaults('Events'),
]}
/>

## Returns

Returns a paginated list of Event objects.

<RequestExample>
  ```bash cURL theme={null}
  curl "https://production.methodfi.com/events?resource_id=pmt_zR3nJG3c99P3X" \
    -H "Method-Version: 2026-03-30" \
    -H "Authorization: Bearer sk_WyZEWVfTcH7GqmPzUPk65Vjc"
  ```

  ```javascript Node.js theme={null}
  const events = await method.events.list({
    resource_id: 'pmt_zR3nJG3c99P3X',
    type: 'payment.update'
  });
  ```

  ```python Python theme={null}
  events = method.events.list({
    'resource_id': 'pmt_zR3nJG3c99P3X',
    'type': 'payment.update'
  })
  ```
</RequestExample>

<ResponseExample>
  ```json theme={null}
  {
    "data": [
      {
        "id": "evt_7pPmytbXgWk7C",
        "type": "credit_score.increased",
        "resource_id": "crs_wXVk4MM7QWNnh",
        "resource_type": "credit_score",
        "data": "CreditScore",
        "diff": {
          "before": {
            "id": "crs_pn4ca33GXFaCE",
            "entity_id": "ent_au22b1fbFJbp8",
            "status": "completed",
            "scores": [
              {
                "score": 724,
                "source": "equifax",
                "model": "vantage_4",
                "factors": []
              }
            ]
          },
          "after": {
            "id": "crs_wXVk4MM7QWNnh",
            "entity_id": "ent_au22b1fbFJbp8",
            "status": "completed", 
            "scores": [
              {
                "score": 741,
                "source": "equifax",
                "model": "vantage_4",
                "factors": []
              }
            ]
          }
        },
        "updated_at": "2024-08-01T16:08:25.462Z",
        "created_at": "2024-08-01T16:08:25.462Z"
      },
      ...
    ],
  }
  ```
</ResponseExample>
